﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight.DataGrid;
using System.Reflection;
using C1.Silverlight.DateTimeEditors;
using System.Windows.Data;

namespace TimeSpanColumn
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            grid.AutoGeneratingColumn += (s, e) =>
            {
                if (e.Property.Name == "TimeTaken")
                {
                    var timespancolumn = new DataGridTimeSpanColumn(e.Property);
                    e.Column = timespancolumn;
                   
                }
            };

            grid.ItemsSource=Data.GetFastestAthletes();  
          
          
        }
    }

    public class DataGridTimeSpanColumn : DataGridBoundColumn
    {
        public DataGridTimeSpanColumn()
        {
            Initialize();
        }

        public DataGridTimeSpanColumn(PropertyInfo property)
            : base(property)
        {
            Initialize();
        }

        protected void Initialize()
        {
            IsReadOnly = false;
        }

        public override object GetCellContentRecyclingKey(C1.Silverlight.DataGrid.DataGridRow row)
        {
            return "TimeEditor";
        }

        public override FrameworkElement CreateCellContent(C1.Silverlight.DataGrid.DataGridRow row)
        {
            var tb = new TextBlock();

            return tb;
        }

        public override void BindCellContent(FrameworkElement cellContent, C1.Silverlight.DataGrid.DataGridRow row)
        {
            var tb = (TextBlock)cellContent;
            var binding = CopyBinding(Binding);
            tb.DataContext = row.DataItem;
            tb.SetBinding(TextBlock.TextProperty, binding);
        }

        public override void UnbindCellContent(FrameworkElement cellContent, C1.Silverlight.DataGrid.DataGridRow row)
        {
            var timeeditor = (TextBlock)cellContent;
            timeeditor.DataContext = null;
        }

        public override FrameworkElement GetCellEditingContent(C1.Silverlight.DataGrid.DataGridRow row)
        {
            var timeeditor = new C1TimeEditor();
            timeeditor.Format = C1TimeEditorFormat.TimeSpan;
            var binding = CopyBinding(Binding);
            timeeditor.SetBinding(C1TimeEditor.ValueProperty, binding);
            return timeeditor;
        }
    }

    public class Data
    {

        public static List<Athlete> GetFastestAthletes()
        {
            var results=new List<Athlete>();
             results.Add(new Athlete(){Position=1,PlayerName="Usain Bolt",TimeTaken=TimeSpan.FromMilliseconds(19190)  });
             results.Add(new Athlete() { Position = 2, PlayerName = "Yohan Blake", TimeTaken = TimeSpan.FromMilliseconds(19260) });  
             results.Add(new Athlete(){Position=3,PlayerName="Michael Johnson",TimeTaken=TimeSpan.FromMilliseconds(19320)});
             results.Add(new Athlete() { Position = 4, PlayerName = "Walter Dix", TimeTaken = TimeSpan.FromMilliseconds(19530) });
             results.Add(new Athlete() { Position = 5, PlayerName = "Tyson Gay", TimeTaken = TimeSpan.FromMilliseconds(19580) });
             results.Add(new Athlete() { Position = 6, PlayerName = "Xavier Carter", TimeTaken = TimeSpan.FromMilliseconds(19630) });
             results.Add(new Athlete() { Position = 7, PlayerName = "Wallace Spearmon", TimeTaken = TimeSpan.FromMilliseconds(19650) });
             results.Add(new Athlete() { Position = 8, PlayerName = "Frankie Fredericks", TimeTaken = TimeSpan.FromMilliseconds(19680) });
             results.Add(new Athlete() { Position = 9, PlayerName = "Pietro Mennea", TimeTaken = TimeSpan.FromMilliseconds(19720) });
             results.Add(new Athlete() { Position = 10, PlayerName = "Michael Marsh", TimeTaken = TimeSpan.FromMilliseconds(19780) }); 

           return results;
        }

        public class Athlete
        {
            public int Position { get; set; }
            public string PlayerName{get;set;}
            public TimeSpan TimeTaken { get; set; }
        }
    }
}
